Index: LMDZ4/trunk/libf/phylmd/calcul_divers.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/calcul_divers.h	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/calcul_divers.h	(revision 996)
@@ -12,6 +12,6 @@
 c surface terre
        DO i=1, klon
-         IF(pctsrf_new(i,is_ter).GT.0.) THEN
-            paire_ter(i)=airephy(i)*pctsrf_new(i,is_ter)
+         IF(pctsrf(i,is_ter).GT.0.) THEN
+            paire_ter(i)=airephy(i)*pctsrf(i,is_ter)
          ENDIF 
        ENDDO
Index: LMDZ4/trunk/libf/phylmd/change_srf_frac_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/change_srf_frac_mod.F90	(revision 996)
+++ LMDZ4/trunk/libf/phylmd/change_srf_frac_mod.F90	(revision 996)
@@ -0,0 +1,157 @@
+!
+! $Header$
+!
+MODULE change_srf_frac_mod
+
+  IMPLICIT NONE
+
+CONTAINS
+! 
+! Change Surface Fractions
+!
+  SUBROUTINE change_srf_frac(itime, dtime, jour, &
+       pctsrf, alb1, alb2, tsurf, u10m, v10m, pbl_tke)
+!
+! This subroutine is called from physiq.F at each timestep. 
+! 1- For each type of ocean (force, slab, couple) receive new fractions only if
+!    it's time to modify (is_modified=true). Otherwise nothing is done (is_modified=false).   
+! If received new fraction :
+! 2- Tests and ajustements are done on the fractions 
+! 3- Initialize variables where a new fraction(new or melted ice) has appered, 
+!
+
+    USE dimphy 
+    USE surface_data, ONLY : type_ocean
+    USE limit_read_mod
+    USE pbl_surface_mod, ONLY : pbl_surface_newfrac
+    USE cpl_mod, ONLY : cpl_receive_frac
+    USE ocean_slab_mod, ONLY : ocean_slab_frac
+
+    INCLUDE "iniprint.h"
+    INCLUDE "indicesol.h"
+    INCLUDE "YOMCST.h"
+
+! Input arguments
+!****************************************************************************************
+    INTEGER, INTENT(IN)                     :: itime   ! current time step
+    INTEGER, INTENT(IN)                     :: jour    ! day of the year
+    REAL,    INTENT(IN)                     :: dtime   ! length of time step (s)
+  
+! In-Output arguments
+!****************************************************************************************
+   
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: pctsrf ! sub-surface fraction
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb1   ! albedo first interval in SW spektrum
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb2   ! albedo second interval in SW spektrum
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: tsurf
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: u10m
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: v10m
+    REAL, DIMENSION(klon,klev+1,nbsrf), INTENT(INOUT) :: pbl_tke
+
+! Loccal variables
+!****************************************************************************************
+    INTEGER                        :: i, nsrf
+    LOGICAL                        :: is_modified   ! true if pctsrf is modified at this time step
+    LOGICAL                        :: test_sum=.FALSE.
+    LOGICAL, DIMENSION(klon,nbsrf) :: new_surf
+    REAL, DIMENSION(klon,nbsrf)    :: pctsrf_old    ! fraction from previous time-step
+    REAL                           :: tmpsum
+
+    pctsrf_old(:,:) = pctsrf(:,:)
+!****************************************************************************************
+! 1) 
+! For each type of ocean (force, slab, couple) receive new fractions only if it's time  
+! to modify (is_modified=true). Otherwise nothing is done (is_modified=false).   
+!****************************************************************************************
+    SELECT CASE (type_ocean)
+    CASE ('force')
+       ! Read fraction from limit.nc
+       CALL limit_read_frac(itime, dtime, jour, pctsrf, is_modified)
+    CASE ('slab')
+       ! Get fraction from slab module
+       CALL ocean_slab_frac(itime, dtime, jour, pctsrf, is_modified)
+    CASE ('couple')
+       ! Get fraction from the coupler
+       CALL cpl_receive_frac(itime, dtime, pctsrf, is_modified)
+    END SELECT
+
+    IF (is_modified) THEN
+!****************************************************************************************
+! 2) 
+! Tests and ajustements on the new fractions :
+! - Put to zero fractions that are too small
+! - Test total fraction sum is one for each grid point
+!
+!****************************************************************************************
+  
+! Test and exit if a fraction is negative
+       IF (MINVAL(pctsrf(:,:)) < 0.) THEN
+          WRITE(lunout,*)'Warning! One or several fractions are negative, itime=',itime
+          WRITE(lunout,*)'at point = ',MINLOC(pctsrf(:,:))
+          WRITE(lunout,*)'value = ',MINVAL(pctsrf(:,:)) 
+          CALL abort_gcm('change_srf_frac','Negative fraction',1)
+       END IF
+
+! Optional test on the incoming fraction 
+       IF (test_sum) THEN
+          DO i= 1, klon
+             tmpsum = SUM(pctsrf(i,:))
+             IF (ABS(1. - tmpsum) > 0.05) CALL abort_gcm('change_srf_frac','Total fraction not equal 1.',1)
+          END DO
+       END IF
+
+! Test for too small fractions of the sum land+landice and ocean+sea-ice
+       WHERE ((pctsrf(:,is_ter) + pctsrf(:,is_lic)) < 2*EPSFRA)
+          pctsrf(:,is_ter) = 0.
+          pctsrf(:,is_lic) = 0.
+       END WHERE
+
+       WHERE ((pctsrf(:,is_oce) + pctsrf(:,is_sic)) < 2*EPSFRA)
+          pctsrf(:,is_oce) = 0.
+          pctsrf(:,is_sic) = 0.
+       END WHERE
+
+! Normalize to force total fraction to be equal one
+       DO i= 1, klon
+          tmpsum = SUM(pctsrf(i,:))
+          DO nsrf = 1, nbsrf
+             pctsrf(i,nsrf) = pctsrf(i,nsrf) / tmpsum
+          END DO
+       END DO
+
+! Test for too small fractions at each sub-surface
+       WHERE (pctsrf(:,is_ter) < EPSFRA)
+          pctsrf(:,is_lic) = pctsrf(:,is_ter) + pctsrf(:,is_lic)
+          pctsrf(:,is_ter) = 0.
+       END WHERE
+
+       WHERE (pctsrf(:,is_lic) < EPSFRA)
+          pctsrf(:,is_ter) = pctsrf(:,is_ter) + pctsrf(:,is_lic)
+          pctsrf(:,is_lic) = 0.
+       END WHERE
+
+       WHERE (pctsrf(:,is_oce) < EPSFRA)
+          pctsrf(:,is_sic) = pctsrf(:,is_oce) + pctsrf(:,is_sic)
+          pctsrf(:,is_oce) = 0.
+       END WHERE
+
+       WHERE (pctsrf(:,is_sic) < EPSFRA)
+          pctsrf(:,is_oce) = pctsrf(:,is_oce) + pctsrf(:,is_sic)
+          pctsrf(:,is_sic) = 0.
+       END WHERE
+
+!****************************************************************************************
+! 3)
+! Initialize variables where a new fraction has appered, 
+! i.e. where new sea ice has been formed
+! or where ice free ocean has appread in a grid cell
+! 
+!****************************************************************************************
+       CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old, tsurf, alb1, alb2, u10m, v10m, pbl_tke)
+
+    END IF ! is_modified
+
+  END SUBROUTINE change_srf_frac
+
+
+END MODULE change_srf_frac_mod
Index: LMDZ4/trunk/libf/phylmd/clesphys.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/clesphys.h	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/clesphys.h	(revision 996)
@@ -47,5 +47,4 @@
        REAL freq_ISCCP, ecrit_ISCCP
        INTEGER :: ip_ebil_phy
-       LOGICAL ok_slab_sicOBS
 
        COMMON/clesphys/cycle_diurne, soil_model, new_oliq,              &
@@ -61,5 +60,5 @@
      &     , ecrit_mth, ecrit_tra, ecrit_reg                            &
      &     , freq_ISCCP, ecrit_ISCCP, ip_ebil_phy                       &
-     &     , ok_slab_sicOBS, ok_lic_melt, cvl_corr                      &
+     &     , ok_lic_melt, cvl_corr                                      &
      &     , qsol0
      
Index: LMDZ4/trunk/libf/phylmd/climb_hq_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/climb_hq_mod.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/climb_hq_mod.F90	(revision 996)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
 MODULE climb_hq_mod
 !
@@ -274,5 +277,5 @@
     REAL, DIMENSION(klon,klev)               :: h_new, q_new
     REAL, DIMENSION(klon)                    :: psref         
-    INTEGER                                  :: k, i
+    INTEGER                                  :: k, i, ierr
 
 !****************************************************************************************
@@ -350,8 +353,10 @@
 !
 !****************************************************************************************
-    DEALLOCATE(Ccoef_Q, Dcoef_Q, Ccoef_H, Dcoef_H)    
-    DEALLOCATE(gamaq, gamah)
-    DEALLOCATE(Kcoefhq)
-
+    DEALLOCATE(Ccoef_Q, Dcoef_Q, Ccoef_H, Dcoef_H,stat=ierr)    
+    IF ( ierr /= 0 )  PRINT*,' pb in dealllocate Ccoef_Q, Dcoef_Q, Ccoef_H, Dcoef_H, ierr=', ierr
+    DEALLOCATE(gamaq, gamah,stat=ierr)
+    IF ( ierr /= 0 )  PRINT*,' pb in dealllocate gamaq, gamah, ierr=', ierr
+    DEALLOCATE(Kcoefhq,stat=ierr)
+    IF ( ierr /= 0 )  PRINT*,' pb in dealllocate Kcoefhq, ierr=', ierr
     
   END SUBROUTINE climb_hq_up
Index: LMDZ4/trunk/libf/phylmd/conf_phys.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 996)
@@ -5,5 +5,5 @@
 !
 
-  subroutine conf_phys(ocean, ok_veget, ok_journe, ok_mensuel, ok_instan, ok_hf, &
+  subroutine conf_phys(ok_journe, ok_mensuel, ok_instan, ok_hf, &
  &                     solarlong0,seuil_inversion, &
  &                     fact_cldcon, facttemps,ok_newmicro,iflag_radia,&
@@ -16,5 +16,5 @@
 
    use IOIPSL
-!!!!   USE surface_data,     ONLY : ocean, ok_veget
+   USE surface_data
 
    implicit none
@@ -51,5 +51,5 @@
 ! Sortie:
   character (len = 6)  :: ocean
-  logical              :: ok_veget, ok_newmicro
+  logical              :: ok_newmicro
   integer              :: iflag_radia
   logical              :: ok_journe, ok_mensuel, ok_instan, ok_hf
@@ -116,5 +116,4 @@
   REAL,SAVE :: ecrit_hf_omp, ecrit_day_omp, ecrit_mth_omp, ecrit_reg_omp
   REAL,SAVE :: ecrit_tra_omp
-  LOGICAL, SAVE :: ok_slab_sicOBS_omp
   REAL,SAVE :: cvl_corr_omp
   LOGICAL,SAVE :: ok_lic_melt_omp
@@ -997,14 +996,4 @@
   call getin('ecrit_reg',ecrit_reg_omp)
 !
-!
-!
-!Config Key  = ok_slab_sicOBS
-!Config Desc =
-!Config Def  = .true.
-!Config Help = Pour faire tourner le slab avec fraction 
-!              de glace de mer Observee
-!
-  ok_slab_sicOBS_omp = .true.
-  call getin('ok_slab_sicOBS', ok_slab_sicOBS_omp)
 !
 !
@@ -1198,5 +1187,4 @@
     ecrit_tra = ecrit_tra_omp
     ecrit_reg = ecrit_reg_omp
-    ok_slab_sicOBS = ok_slab_sicOBS_omp
     cvl_corr = cvl_corr_omp
     ok_lic_melt = ok_lic_melt_omp
@@ -1213,7 +1201,27 @@
 !$OMP MASTER
 
+! Attribution of new parmeters according to parameters in .def
+    IF (ocean=='couple' .OR. ocean=='opa8') THEN
+       type_ocean='couple'
+       version_ocean='opa8'
+    ELSE IF (ocean=='nemo') THEN
+       type_ocean='couple'
+       version_ocean='nemo'
+    ELSE IF (ocean=='force') THEN
+       type_ocean='force'
+       version_ocean='xxxxxx'
+    ELSE IF (ocean=='slab') THEN
+       type_ocean='slab'
+       version_ocean='sicOBS'
+    ELSE
+       WRITE(numout,*)' ERROR ocean not valid : ocean= ', ocean
+       CALL abort_gcm('conf_phys','ocean not valid',1)
+    END IF
+
   write(numout,*)' ##############################################'
   write(numout,*)' Configuration des parametres de la physique: '
   write(numout,*)' Config ocean = ', ocean
+  write(numout,*)' Type ocean = ', type_ocean
+  write(numout,*)' Version ocean = ', version_ocean
   write(numout,*)' Config veget = ', ok_veget
   write(numout,*)' Sortie journaliere = ', ok_journe
